#!/usr/bin/env perl
#
# seqconv.pl informat outformat infile outfile
#

use strict;
use Bio::SeqIO;

if (4 != @ARGV) {
  die "should be run: seqconv.pl informat outformat infile outfile";
}

my $informat = lc($ARGV[0]);
my $outformat = lc($ARGV[1]);
my $infile = $ARGV[2];
my $outfile = $ARGV[3];

my $inh = Bio::SeqIO->new(-file => $infile, -format => $informat);
my $outh = Bio::SeqIO->new(-file => '>'.$outfile, -format => $outformat);

my $seq = $inh->next_seq();
$outh->write_seq($seq);


