#!/usr/bin/env python
#
# seqconv.py informat outformat infile outfile
#

import sys
try:
  from Bio import SeqIO
except:
  print("BioPython modules have to be available")
  sys.exit(1)

runstr = "it should be run: seqconv.py informat outformat infile outfile"
args = sys.argv[1:]
if (4 != len(args)):
  print(runstr)
  sys.exit(1)

informat = args[0].lower()
outformat = args[1].lower()
infile = args[2]
outfile = args[3]

fhin = ""
fhout = ""

try:
  fhin = open(infile, 'r')
  fhout = open(outfile, 'w')
except:
  print("cannot open the files")
  sys.exit(1)

try:
  SeqIO.write(SeqIO.parse(fhin, informat), fhout, outformat)
except:
  print("can not parse files under the requested formats")
  sys.exit(1)

fhin.close()
fhout.close()



