#!/usr/bin/env python
#
# seqload.py database identifier filename
#

import sys
try:
  from Bio import SeqIO
except:
  print("BioPython modules have to be available")
  sys.exit(1)

try:
  from Bio import Entrez
except:
  print("Entrez biopython module has to be available")
  sys.exit(1)

runstr = "it should be run: seqload.py database identifier filename"
args = sys.argv[1:]
if (3 != len(args)):
  print(runstr)
  sys.exit(1)

database = args[0]
identifier = args[1]
filename = args[2]

handle = Entrez.efetch(db=database, rettype='genbank', id=identifier)
try:
  seq_record = SeqIO.read(handle, 'genbank')
except:
  print("No sequence found.")
  sys.exit(1)

handle.close()

fh = open(filename, 'w')
SeqIO.write([seq_record], fh, 'genbank')
fh.close()



