#!/usr/bin/env python
#
# (C) Martin Saturka, http://www.bioplexity.org/
# This script is available under the MIT license.
#
# Script parameters:
# file.csv .. csv-formated structure file
# head.txt .. header file for the pdb file
#

import sys, os, time
import getopt

class ConCoords(object):
  def __init__(self):
    self.csvfname = "input.csv"
    self.headname = ""

  def work(self):

    if not "" == self.headname:
      try:
        fhead = open(self.headname, "r")
      except:
        return False
      for line in fhpdb:
        if line.startswith("#"):
          continue
        if 0 == len(line):
          continue
        print(line)
      fhead.close()

    try:
      fhcsv = open(self.csvfname, "r")
    except:
      return False

    wstate = True

    cur_resid_atom = 0
    cur_resid_rank = 0
    cur_chain_symb = "none"

    for line in fhcsv:
      inline = line.rstrip()

      if inline.startswith("#"):
        continue

      if 0 == len(inline):
        continue

      indata = []
      for item in inline.split(","):
        indata.append(item.strip("\"\'"))

      if not 4 == len(indata):
        wstate = False
        break

      lnames = indata[0].split(":")
      if not 7 == len(lnames):
        wstate = False
        break

      lstring = ""
      linetype = lnames[0].upper()
      if 'A' == linetype:
        lstring += "ATOM  "
      else:
        lstring += "HETATM"

      lrank = lnames[1]
      if 5 < len(lrank):
        wstate = False
        break
      lstring += (5 - len(lrank)) * " "
      lstring += lrank

      lstring += 2 * " "

      latom = lnames[6]
      if 3 < len(latom):
        wstate = False
        break

      lstring += (3 - len(latom)) * " "
      lstring += latom

      lstring += " "

      lresiduum = lnames[4]
      if 3 < len(lresiduum):
        wstate = False
        break

      lstring += (3 - len(lresiduum)) * " "
      lstring += lresiduum

      lstring += " "

      lchain = lnames[2]
      if 1 < len(lchain):
        wstate = False
        break

      lstring += (1 - len(lchain)) * " "
      lstring += lchain

      rrank = lnames[3]
      if 4 < len(rrank):
        wstate = False
        break

      lstring += (4 - len(rrank)) * " "
      lstring += rrank

      lstring += 4 * " "

      for item in indata[1:]:
        try:
          curval = float(item)
          if curval >= 1000:
            wstate = False
            break
          if curval <= -1000:
            wstate = False
            break
        except:
          wstate = False
          break
        curstr = "%(val).3f" % {'val': curval}
        lstring += (8 - len(curstr)) * " "
        lstring += curstr

      if not wstate:
        break

      lstring += 12 * " "
      lstring += 11 * " "

      lone = "X"
      if 0 < len(latom):
        lone = latom[0]
      lstring += lone

      lstring += 2 * " "

      #lstring += "\n"

      print(lstring)


    fhcsv.close()
    return wstate


#params: -i input_file.csv, -h header_file
if ('__main__' == __name__):
  args = sys.argv[1:]
  argl = len(args)
  runstring = "Should be run: csv2pdb.py -i file.csv [-h header.txt]\n"

  csvfname = ""
  headname = ""

  optlist = []
  try:
    optlist, args = getopt.getopt(args, 'i:h:')
    for opt, arg in optlist:
      if "-i" == opt:
        csvfname = arg
      if "-h" == opt:
        headname = arg

  except:
    sys.stderr.write(runstring)
    sys.exit(1)

  isok = True
  if 0 == len(csvfname):
    isok = False
    sys.stderr.write("no input file\n")

  if not isok:
    sys.stderr.write(runstring)
    sys.exit(1)

  conc = ConCoords()
  conc.csvfname = csvfname
  conc.headname = headname

  rv = conc.work()
  if not rv:
    print("work failed")
    sys.exit(1)




