#!/usr/bin/env Rscript
#
# rmsdiff.R points1.csv points2.csv output-rmsd.csv
#

args <- commandArgs(TRUE)
if (3 != length(args)) {
  stop("should be run: rmsdiff.R points1.csv points2.csv output.csv")
}

pp1tab <- read.csv(args[1], row.names=1, header=FALSE, sep=",", comment="#")
pp2tab <- read.csv(args[2], row.names=1, header=FALSE, sep=",", comment="#")
pp1 <- as.matrix(pp1tab)
pp2 <- as.matrix(pp2tab)

pp1.dims <- attributes(pp1)$dim
pp2.dims <- attributes(pp2)$dim
if (3 != pp1.dims[2]) {
  stop("point matricces [1] should have 3 columns")
}
if (3 != pp2.dims[2]) {
  stop("point matricces [2] should have 3 columns")
}
if (pp1.dims[1] != pp2.dims[1]) {
  stop("point matricces should have the same count of rows")
}

ddimv <- attributes(pp1)$dim

outv <- sqrt(sum((pp2 - pp1) ^ 2) / ddimv[1])
outm <- matrix(outv, nrow=1, ncol=1)

colnames(outm) <- c("rmsd")

write.table(outm, args[3], row.names=FALSE, col.names=TRUE, sep=",")



